'use strict';import{AssertionError,AttributeError,BaseException,DeprecationWarning,Exception,IndexError,IterableError,KeyError,NotImplementedError,RuntimeWarning,StopIteration,UserWarning,ValueError,Warning,__JsIterator__,__PyIterator__,__Terminal__,__add__,__and__,__call__,__class__,__envir__,__eq__,__floordiv__,__ge__,__get__,__getcm__,__getitem__,__getslice__,__getsm__,__gt__,__i__,__iadd__,__iand__,__idiv__,__ijsmod__,__ilshift__,__imatmul__,__imod__,__imul__,__in__,__init__,__ior__,__ipow__,
__irshift__,__isub__,__ixor__,__jsUsePyNext__,__jsmod__,__k__,__kwargtrans__,__le__,__lshift__,__lt__,__matmul__,__mergefields__,__mergekwargtrans__,__mod__,__mul__,__ne__,__neg__,__nest__,__or__,__pow__,__pragma__,__pyUseJsNext__,__rshift__,__setitem__,__setproperty__,__setslice__,__sort__,__specialattrib__,__sub__,__super__,__t__,__terminal__,__truediv__,__withblock__,__xor__,abs,all,any,assert,bin,bool,bytearray,bytes,callable,chr,copy,deepcopy,delattr,dict,dir,divmod,enumerate,filter,float,getattr,
hasattr,hex,input,int,isinstance,issubclass,len,list,map,max,min,object,oct,ord,pow,print,property,py_TypeError,py_iter,py_metatype,py_next,py_reversed,py_typeof,range,repr,round,set,setattr,sorted,str,sum,tuple,zip}from"./org.transcrypt.__runtime__.js";import{Observable}from"./othello.util.js";var __name__="othello.game";export var BLACK="black";export var WHITE="white";export var EMPTY="";export var _SIZE=8;export var _DIRECTIONS=function(){var __accu0__=[];for(var x of tuple([-1,0,1]))for(var y of tuple([-1,
0,1]))if(x!=0||y!=0)__accu0__.append(tuple([x,y]));return __accu0__}();export var Othello=__class__("Othello",[Observable],{__module__:__name__,get __init__(){return __get__(this,function(self){__super__(Othello,"__init__")(self);self.BLACK=BLACK;self.WHITE=WHITE;self.history=[];self.turn=BLACK;self.surrendered=false;self.last_move=null;self.last_flipped=[];self.reset()})},get _is_on_board(){return function(x,y){return 0<=x&&x<_SIZE&&(0<=y&&y<_SIZE)}},get _is_valid(){return __get__(this,function(self,
disk,x,y){if(!self._is_on_board(x,y)||self.board[x][y]!=EMPTY)return false;var other_disk=disk==BLACK?WHITE:BLACK;for(var [xdir,ydir]of _DIRECTIONS){var __left0__=tuple([x+xdir,y+ydir]);var newx=__left0__[0];var newy=__left0__[1];while(self._is_on_board(newx,newy)&&self.board[newx][newy]==other_disk){newx+=xdir;newy+=ydir}if(self._is_on_board(newx,newy)&&self.board[newx][newy]==disk&&(newx-xdir!=x||newy-ydir!=y))return true}return false})},get _get_flipped(){return __get__(this,function(self,disk,
x,y){if(!self._is_on_board(x,y)||self.board[x][y]!=EMPTY)return[];var other_disk=disk==BLACK?WHITE:BLACK;var flipped=[];for(var [xdir,ydir]of _DIRECTIONS){var __left0__=tuple([x+xdir,y+ydir]);var newx=__left0__[0];var newy=__left0__[1];while(self._is_on_board(newx,newy)&&self.board[newx][newy]==other_disk){newx+=xdir;newy+=ydir}if(!self._is_on_board(newx,newy)||self.board[newx][newy]!=disk)continue;while(true){newx-=xdir;newy-=ydir;if(newx==x&&newy==y)break;flipped.append(tuple([newx,newy]))}}return flipped})},
get _can_move(){return __get__(this,function(self,disk){for(var x=0;x<_SIZE;x++)for(var y=0;y<_SIZE;y++)if(self._is_valid(disk,x,y))return true;return false})},get reset(){return __get__(this,function(self){self.board=function(){var __accu0__=[];for(var x=0;x<_SIZE;x++)__accu0__.append(function(){var __accu1__=[];for(var y=0;y<_SIZE;y++)__accu1__.append(EMPTY);return __accu1__}());return __accu0__}();self.board[3][3]=WHITE;self.board[3][4]=BLACK;self.board[4][3]=BLACK;self.board[4][4]=WHITE;self.history=
[];self.turn=BLACK;self.surrendered=false;self.last_move=null;self.last_flipped=[];self.notify_all()})},get surrender(){return __get__(this,function(self){self.surrendered=true;self.notify_all()})},get score(){return __get__(this,function(self){var __left0__=tuple([0,0]);var b=__left0__[0];var w=__left0__[1];for(var row of self.board)for(var d of row)if(d==BLACK)b++;else if(d==WHITE)w++;return dict([[BLACK,b],[WHITE,w]])})},get game_over(){return __get__(this,function(self){return self.surrendered||
!self._can_move(BLACK)&&!self._can_move(WHITE)})},get move(){return __get__(this,function(self,x,y){var flipped=self._get_flipped(self.turn,x,y);if(len(flipped)==0)return false;self.last_move=tuple([x,y]);self.last_flipped=flipped;self.history.append(self.last_move);self.board[x][y]=self.turn;for(var [i,j]of flipped)self.board[i][j]=self.turn;var next_turn=self.turn==BLACK?WHITE:BLACK;if(self._can_move(next_turn))self.turn=next_turn;self.notify_all();return true})},get moves(){return __get__(this,
function(self,disk){if(typeof disk=="undefined"||disk!=null&&disk.hasOwnProperty("__kwargtrans__"))var disk=null;if(disk===null)var disk=self.turn;var moves=[];for(var x=0;x<_SIZE;x++)for(var y=0;y<_SIZE;y++)if(self._is_valid(disk,x,y))moves.append(tuple([x,y]));return moves})}});

//# sourceMappingURL=othello.game.map